VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Vincent Richard; vrichard@rational.com; 13-Nov-2001
'cppinterface add-in, code handling the behaviour of the cppinterface stereotype
Option Explicit
 
Private Function IsCppInterfaceClass(aClass As RoseClass) As Boolean
    Dim assignedLanguage As String
    assignedLanguage = aClass.GetAssignedLanguage()
    IsCppInterfaceClass = (assignedLanguage = "ANSI C++" Or assignedLanguage = "VC++") And aClass.Stereotype = "cppinterface"
End Function

Private Sub MakeMethodVirtualPure(anOperation As RoseOperation)
    anOperation.Abstract = True
    anOperation.Stereotype = "abstract"
End Sub

Private Sub MakeClassCppInterface(aClass As RoseClass)
    aClass.Abstract = True
    Dim allOperations As RoseOperationCollection
    Set allOperations = aClass.Operations
    Dim i As Integer
    For i = 1 To allOperations.Count
        MakeMethodVirtualPure allOperations.GetAt(i)
    Next i
End Sub

Public Sub OnModifiedModelElementEx(roseApp As RoseApplication, objItem As RoseItem, intReason As Integer, vntInfo As Variant)
    'intReason = 8 <=> Stereotype Changed
    If intReason = 8 And objItem.IdentifyClass() = "Class" Then
        If IsCppInterfaceClass(objItem) Then
            MakeClassCppInterface objItem
        End If
    End If
End Sub

Public Sub OnNewModelElement(roseApp As RoseApplication, objItem As RoseItem)
    If objItem.IdentifyClass() = "Operation" Then
        If IsCppInterfaceClass(objItem.ParentClass) Then
            MakeMethodVirtualPure objItem
        End If
    ElseIf objItem.IdentifyClass() = "Class" Then
        If IsCppInterfaceClass(objItem) Then
            MakeClassCppInterface objItem
        End If
    End If
End Sub
